


.nolist
.include "m8def.inc"
.list

.equ clock = 4000000                            ; Systemtakt in Hz 
.equ BAUD = 19200;9600
.equ	cr=	13	;ASCII-Code fr ENTER
.equ	lf=	10	;ASCII-Code fr NEW LINE neue zeile





.equ sendon_port=portB         
.equ sendon_ddr=ddrB 
.equ sendon_bit=pb1 


.equ empfon_port=portB         
.equ empfon_ddr=ddrB
.equ empfon_bit=pb2 



.def null=r5                ;immer Null
.def befehl	=	r10			;enthlt den auszugebenden 8bit-befehl




.def temp4	=	r16
.def temp	=	r17
.def temp1	=	r18
.def temp2	=	r19
.def temp3	=	r20
.def temp5	=	r21

.def delay1	=	r22
.def delay2	=	r23

.def dta	                  =	r24 ;sende register



.dseg                   ;SRAM-Variablen 
.org	0x60
temp_lsb:          .byte 1  
temp_msb:          .byte 1 
th_reg:            .byte 1 
tl_reg:            .byte 1 
res1:              .byte 1 
res2:              .byte 1 
count_re:          .byte 1 
count_pc:          .byte 1 
crc:               .byte 1 
id_rom:            .byte 1 
rsbuff:            .byte 7 


.cseg
.org	0
; hier geht das Programm los
; Interrupt-Vektoren
;
reset:	rjmp	start		;Programm-Start
intr0:	reti			;External Interrupt Request 0
intr1:	reti			;External Interrupt Request 1
t2comp:	reti			;Timer/Counter2 Compare Match
t2ovf:	reti			;Timer/Counter2 Overflow
t1capt:	reti			;Timer/Counter1 Capture Event
t1coma:	reti			;Timer/Counter1 Compare Match A
t1comb:	reti			;Timer/Counter1 Compare Match B
t1ovf:	reti			;Timer/Counter1 Overflow
t0ovf:	reti			;Timer/Counter0 Overflow
spistc:	reti			;SPI, STC Serial Transfer Complete
usrxc:	reti  ; usrx_int; 			;RXC USART, Rx Complete
usudre:	reti			;UDRE USART Data Register Empty
ustxc:	reti			;TXC USART, Tx Complete
adc_cc:	reti			;ADC Conversion Complete
ee_rdy:	reti			;EEPROM Ready
anacom:	reti			;Analog Comparator
twi:	reti			;Two-wire Serial Interface
spmrdy:	reti			;Store Program Memory Ready


     
start:

ldi temp, Low(RAMEND)
out SPL, temp
ldi temp, high(RAMEND)
out SPH, temp          ;Stack Pointer Intialisieren


ldi	temp,0b00000010
	out	ddrd,temp		;PortD, nur TXD als Ausgang
   



sbi sendon_port-1,sendon_bit            ; Ausgang
sbi empfon_port-1,empfon_bit            ; Ausgang









;UART Initalisierung
 
    ldi	temp,low((clock/(16*baud))-1)
	out	ubrrl,temp		;9600 Baud setzen
	ldi	temp,high((clock/(16*baud))-1)
	out	ubrrh,temp		;USART Baudratenregister auf
	
	
	ldi	temp,(1<<ursel)|(1<<ucsz1)|(1<<ucsz0)
	out	ucsrc,temp		;8 Datenbits, 1 Stoppbit
	ldi	temp,(1<<rxen)|(1<<txen);
	;ldi	temp,(1<<RXCIE)|(1<<rxen)|(1<<txen);
	out	ucsrb,temp		;Sender aktivieren
;

;
;sei 



;sbi sendon_port,sendon_bit 

;sbi empfon_port,empfon_bit 





;******************************************************************************
;			Hauptschleife
;******************************************************************************


mainloop:
 	;ROHDATEN AUSGABE
	rcall sens
	rcall waiting  ;1sekunde warten
	
	rjmp Mainloop















sens:
  
                  rcall reset_pulse;
	rcall skip_rom
	rcall convert_t
                  rcall reset_pulse
;	rcall skip_rom
	rcall read_sens1   ;einen sensor mit seiner id direkt ansprechen
	rcall read_scratchpad
	rcall reset_pulse

;rohdaten senden

lds dta, temp_lsb      ;temperatur
rcall senden
ldi dta,cr ;enter
rcall senden


;rcall waiting  ;1sekunde warten

lds dta, temp_msb
rcall senden
ldi dta,cr ;enter

rcall senden
     ret










senden:
   
   sbis	ucsra,udre		;Sendepuffer leer?
   rjmp    senden
    out     UDR,  dta ;temp1
    ret                                  





















waiting:
 push xl                    ;Inhalt sichern
 ldi xl,80                  ;>15ms warten, nachdem Vcc > 4,5V ist
; ldi xl,20                  ;>15ms warten, nachdem Vcc > 4,5V ist
powerupwait:                ;hier 250ms warten, dafr keine Spannungsprfung
 rcall delay5ms
 dec xl
 brne powerupwait
 pop xl                     ;alten Inhalt zurck holen

ret


delay5ms:               ;5ms Pause fr manche Befehle
 push zl                    ;alten Inhalt
 push zh                    ;sichern
 ldi zh,high(clock/11000*50);Verzgerungswert fr 50ms
 ldi zl,low(clock/11000*50) ;setzen
delay5ms1:
 rcall delay5ms2            ;7 Takte vertrdeln
 sbiw zh:zl,1               ;-1 (2 weitere Takte)
 brne delay5ms1             ;0? nein, nochmal (2 Takte)
 pop zh                     ;alten Inhalt
 pop zl                     ;zurck holen
delay5ms2: 
 ret                        ;zurck...




;******************************************************************************
;******************************************************************************
;ds18s20 routinen
;******************************************************************************

reset_pulse:
	sbi ddrc, 0				;pc0 als ausgang
	cbi portc, 0	
	rcall wait500us				;mcu hlt bus fr mindestens 480us low
	cbi ddrc, 0				;lsst den bus los, geht in rx-mode
	rcall wait70us				;wartet 70 us
	
	wait_presence_pulse:
	sbic pinc, 0
	rjmp wait_presence_pulse		;wartet auf presence pulse
	
	wait_presence_pulse_end:
	sbis pinc, 0				
	rjmp wait_presence_pulse_end 		;wartet bis presence pulse fertig

	rcall wait410us				;wartet 412 us

ret

;******************************************************************************

write_1:					;schreibt eine 1
	
	sbi ddrc, 0				;PC0 Ausgang
	cbi portc, 0				;bus auf low
	rcall wait6us				;wartet 8us (maximum sind 15us)
	cbi ddrc, 0				;lsst bus los, nun durch ext R auf high
	rcall wait64us				;slot muss mind. 60us lang sein
	ret

;******************************************************************************
write_0:					;schreibt eine 0
	
	sbi ddrc, 0				;PC0 ausgang
	cbi portc, 0			;bus auf low
	rcall wait60us
	cbi ddrc, 0				;lsst bus los, nun durch ext R auf high
	rcall wait10us				;slot muss mind. 60us lang sein

	ret

;******************************************************************************
write_command:					;gibt einen befehl aus, lsb zuerst

	sbrs befehl, 0	
	rcall write_0
	sbrc befehl, 0
	rcall write_1
	
	ror befehl				;nchstes bit
	ldi temp, 7

	write_command_1:
	sbrs befehl, 0	
	rcall write_0
	sbrc befehl, 0
	rcall write_1
	ror befehl
	dec temp
	brne write_command_1

ret

;******************************************************************************
skip_rom:					;gibt den befehl "Skip Rom" an den
	ldi temp, 0xCC				; sensor aus
	mov befehl, temp
	rcall write_command
ret

;******************************************************************************
convert_t:					;gibt den befehl "Convert T" an den
	ldi temp, 0x44				; sensor aus
	mov befehl, temp
	rcall write_command			

	cbi portc, 0
	sbi ddrc, 0				;bus low fr 6us
	rcall wait6us
	cbi ddrc, 0				;bus loslassen
	rcall wait9us				;nach 9us samplen
	convert_t_1:
	sbis pinc, 0				;wartet bis conversion zu ende ist
	rjmp convert_t_1
	
ret

;******************************************************************************
read_scratchpad:				;gibt den befehl "Read Scratchpad" 
	ldi temp, 0xBE				; an den sensor aus
  ;nach dem befehl werden alle 9 byte
  ; geschickt und eingelesen
	
	mov befehl, temp
	rcall write_command

	rcall read_bit				
	sts temp_lsb, temp2		                                    

	rcall read_bit
                 sts temp_msb, temp2

                   rcall read_bit
	sts TH_reg, temp2
	
	rcall read_bit
	sts TL_reg, temp2
	
	rcall read_bit
	sts res1, temp2
	
	rcall read_bit
	sts res2, temp2
	
	rcall read_bit
	sts count_re, temp2
	
	rcall read_bit
	sts count_pc, temp2
	
	rcall read_bit
	sts crc, temp2

                  ret


	;*****************************************************
	read_bit:
	ldi temp2, 0				;temp2 auf 0
	ldi temp, 8				;8mal durchfhren

	read_bit_0:
	ror temp2
	cbi portc, 0
	sbi ddrc, 0				;bus low fr 6us
	rcall wait6us
	cbi ddrc, 0				;bus loslassen.
	rcall wait9us				;nach 9us samplen

	sbis pinc, 0				;schaut nach ob nun eine 0 anliegt
	rjmp read_bit_1				;wenn ja, springe weiter
	ldi temp1, 128
;add temp2, r26
	add temp2, temp1
	rjmp read_bit_2

	read_bit_1:				
	ldi temp1, 0
	add temp2, temp1

	read_bit_2:

	rcall wait55us
	dec temp
	brne read_bit_0				;zum schluss steht das fertige byte in tmp3
ret








read_sens1:                         ; an den sensor aus
	
;******************************************************************************
           ldi ZL, LOW(ID_Tabelle10*2)         
           ldi ZH, HIGH(ID_Tabelle10*2)        

  ldi temp, 0x55        ; MATCH-ROM
  mov befehl, temp
  rcall write_command


       ldi    temp4,8     ;8 Byte ausgeben
       loop:  lpm    befehl,Z+   ;Byte aus Flash holen
       rcall  write_command
       dec    temp4
       brne   loop

ret











SEND:

ma1400:	



                  ldi	xl,low(rsbuff)
	ldi	xh,high(rsbuff)		;Zeiger auf RS232-Puffer
	ldi	temp3,6			;7 Zeichen senden
ma1410:	
    ld	dta,x+			;Zeichen holen
	rcall	uart_tx			;Zeichen senden
	dec	temp3			;alle Zeichen gesendet?
	brne	ma1410			;nein -> Schleife
;RCALL AS
;LDI DTA,cr
;rcall	uart_tx			;Zeichen senden
RET
;RJMP mainloop



uart_tx:
   
   sbis	ucsra,udre		;Sendepuffer leer?
   rjmp    uart_tx
    out     UDR,  dta ;temp1
    ret                                  











wait500us:
;  ldi delay2, 6
;  ldi delay1, 200
;  wait500us_1:
;  inc delay1
;  brne wait500us_1
;  dec delay2
;  brne wait500us_1
; ============================= 
;   Warteschleifen-Generator 
;     2000 Zyklen:
; ----------------------------- 
; warte 1998 Zyklen:
          ldi  R20, $03
WGLOOP0:  ldi  R22, $DD
WGLOOP1:  dec  R22
          brne WGLOOP1
          dec  R20
          brne WGLOOP0
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 


  ret
;******************************************************************************
wait410us:
;  ldi delay2, 5
;  ldi delay1, 185
;  wait410us_1:
;  inc delay1
;  brne wait410us_1
;  dec delay2
;  brne wait410us_1

; ============================= 
;   Warteschleifen-Generator 
;     1640 Zyklen:
; ----------------------------- 
; warte 1638 Zyklen:
          ldi  R20, $03
WGLOOPP0:  ldi  R22, $B5
WGLOOPP1:  dec  R22
          brne WGLOOPP1
          dec  R20
          brne WGLOOPP0
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 




  ret
;******************************************************************************
wait70us:
  ;ldi delay1, 185
  ;wait70us_1:
  ;dec delay1
  ;brne wait70us_1
  ; ============================= 
;   Warteschleifen-Generator 
;     280 Zyklen:
; ----------------------------- 
; warte 279 Zyklen:
          ldi  R20, $5D
WGLOOPPP0:  dec  R20
          brne WGLOOPPP0
; ----------------------------- 
; warte 1 Zyklus:
          nop
; ============================= 

  
  ret
;******************************************************************************
wait64us:
;  ldi delay1, 170
;  wait64us_1:
;  dec delay1
;  brne wait64us_1
; ============================= 
;   Warteschleifen-Generator 
;     256 Zyklen:
; ----------------------------- 
; warte 255 Zyklen:
          ldi  R20, $55
WGLOO2P0:  dec  R20
          brne WGLOO2P0
; ----------------------------- 
; warte 1 Zyklus:
          nop
; ============================= 



  ret
;******************************************************************************
wait60us:
 ; ldi delay1, 160
 ; wait60us_1:
 ; dec delay1
 ; brne wait60us_1
 ; ============================= 
;   Warteschleifen-Generator 
;     240 Zyklen:
; ----------------------------- 
; warte 240 Zyklen:
          ldi  R20, $50
WGLOO3P0:  dec  R20
          brne WGLOO3P0
; ============================= 

 
 
  ret
;******************************************************************************
wait55us:
;  ldi delay1, 141
;  wait55us_1:
;  dec delay1
;  brne wait55us_1
; ============================= 
;   Warteschleifen-Generator 
;     220 Zyklen:
; ----------------------------- 
; warte 219 Zyklen:
          ldi  R20, $49
WGLOO7P0:  dec  R20
          brne WGLOO7P0
; ----------------------------- 
; warte 1 Zyklus:
          nop
; ============================= 


  ret
;******************************************************************************
wait10us:
;  ldi delay1, 26
;  wait10us_1:
;  dec delay1
;  brne wait10us_1
; ============================= 
;   Warteschleifen-Generator 
;     40 Zyklen:
; ----------------------------- 
; warte 39 Zyklen:
          ldi  R20, $0D
WGLOO9P0:  dec  R20
          brne WGLOO9P0
; ----------------------------- 
; warte 1 Zyklus:
          nop
; ============================= 



  ret

;******************************************************************************
wait6us:
;  ldi delay1, 13
;  wait6us_1:
;  dec delay1
;  brne wait6us_1
;  nop
;  nop
; ============================= 
;   Warteschleifen-Generator 
;     24 Zyklen:
; ----------------------------- 
; warte 24 Zyklen:
          ldi  R20, $08
WGLOOJP0:  dec  R20
          brne WGLOOJP0
; ============================= 


  ret
;******************************************************************************
wait9us:
;  ldi delay1, 21
;  wait9us_1:
;  dec delay1
;  brne wait9us_1
;  nop
;  nop
; ============================= 
;   Warteschleifen-Generator 
;     36 Zyklen:
; ----------------------------- 
; warte 36 Zyklen:
          ldi  R20, $0C
WGLOOLP0:  dec  R20
          brne WGLOOLP0
; ============================= 




  ret












WARTEN:
; ============================= 
;   Warteschleifen-Generator 
;     20000000 Zyklen:
; ----------------------------- 
; warte 19999992 Zyklen:
          ldi  R20, $BF
WGLOOAP0:  ldi  R22, $A7
WGLOOAP1:  ldi  R23, $D0
WGLOOAP2:  dec  R23
          brne WGLOOAP2
          dec  R22
          brne WGLOOAP1
          dec  R20
          brne WGLOOAP0
; ----------------------------- 
; warte 6 Zyklen:
          ldi  R20, $02
WGLOOAP3:  dec  R20
          brne WGLOOAP3
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 

; ============================= 



RET

ID_Tabelle1:
.db  16,136,190,113,1,8,0,167


ID_Tabelle2:
.db  16,152,46,113,1,8,0,75


ID_Tabelle3:
.db  16,37,74,113,1,8,0,8

ID_Tabelle4:
.db  16,215,97,113,1,8,0,156

ID_Tabelle5:
.db  16,86,244,113,1,8,0,36


ID_Tabelle6:
;.db  16,186,79,123,1,8,0,84
.db  16,51,94,123,1,8,0,153

ID_Tabelle7:
.db  16,170,84,123,1,8,0,3

ID_Tabelle8:
.db  16,7,41,123,1,8,0,148

ID_Tabelle9:
.db  16,185,42,123,1,8,0,206

ID_Tabelle10:
.db  16,0,66,123,1,8,0,112

